Generic Image Library: kth_channel_deref_fn< K, SrcP > Struct Template Reference

###  | #  |

Public Types | Public Member Functions | Static Public Attributes | List of all members
kth_channel_deref_fn< K, SrcP > Struct Template Reference
Pixel Dereference Adaptor » Models

Function object that returns a grayscale reference of the K-th channel (specified as a template parameter) of a given reference. Models: PixelDereferenceAdaptorConcept. More...

`#include <image_view_factory.hpp>`

## Public Types
using | const_t = kth_channel_deref_fn<K,const_ref_t>
using | value_type = typename pixel_value_type<channel_t,gray_layout_t>::type
using | const_reference = typename pixel_reference_type<channel_t,gray_layout_t,false,false>::type
using | argument_type = SrcP
using | reference = mp11::mp_if_c<is_mutable, ref_t, value_type>
using | result_type = reference

## Public Member Functions
template<typename P >
| kth_channel_deref_fn (const kth_channel_deref_fn< K, P > &)
result_type | operator() (argument_type srcP) const

## Static Public Attributes
static constexpr bool | is_mutable

## Detailed Description

template<int K, typename SrcP>
struct boost::gil::detail::kth_channel_deref_fn< K, SrcP >

Function object that returns a grayscale reference of the K-th channel (specified as a template parameter) of a given reference. Models: PixelDereferenceAdaptorConcept.

If the input is a pixel value or constant reference, the function object is immutable. Otherwise it is mutable (and returns non-const reference to the k-th channel)

Template Parameters

  SrcP | reference to PixelConcept (could be pixel value or const/non-const reference) Examples: pixel<T,L>, pixel<T,L>&, const pixel<T,L>&, planar_pixel_reference<T&,L>, planar_pixel_reference<const T&,L>

## Member Data Documentation

## ◆ is_mutable

template<int K, typename SrcP >

bool is_mutable
| staticconstexpr

Initial value:
=
pixel_is_reference<SrcP>::value && pixel_reference_is_mutable<SrcP>::value

The documentation for this struct was generated from the following file:

- image_view_factory.hpp